Unit qsl5e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure qsl5e(var RINT :Extended; var A :Extended; var B :Extended;
                F :Func_F1E; E :Extended; var ALFA :Extended;
                var BETA :Extended; var XA :Extended; var E1 :Extended);

implementation

procedure qsl5e(var RINT :Extended; var A :Extended; var B :Extended;
                F :Func_F1E; E :Extended; var ALFA :Extended;
                var BETA :Extended; var XA :Extended; var E1 :Extended);
var
N,IL,O :Integer;
RINT2,I,J,K,L,M,C,W,TAU,EPS,Z2,H,Z1,P,H0,Q,R :Extended;
NI :Boolean;
AY :Array [0..6] of Extended;
BY :Array [0..6] of Extended;
KSI :Array [0..6] of Extended;
OM :Array [0..2] of Integer;
D :Array [0..2] of Extended;
const
HM :Extended = 2.0e-10;
SYS059 :Extended = 1.7E38;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39;
begin
{   DATA  FORTRAN  }
AY[0] := 0.023809523809e0;
AY[1] := 0.243809523809e0;
AY[2] := 0.023809523809e0;
AY[3] := 0.138413023681e0;
AY[4] := 0.215872690605e0;
AY[5] := 0.215872690605e0;
AY[6] := 0.138413023681e0;
BY[0] := -0.076190474e0;
BY[1] := 0.243809523809e0;
BY[2] := -0.076190474e0;
BY[3] := 0.183701962e0;
BY[4] := -0.229416249e0;
BY[5] := -0.229416249e0;
BY[6] := 0.183701962e0;
KSI[0] := 0.0e0;
KSI[1] := 0.5e0;
KSI[2] := 1.0e0;
KSI[3] := 0.084888051861e0;
KSI[4] := 0.265575603265e0;
KSI[5] := 0.734424396735e0;
KSI[6] := 0.915111948139e0;
IL := 1;
EPS := E;
XA := -SYS059;
NI := ( A  > B );
if (  not ( (NI) ) ) 
 then goto _1;
C := A;
A := B;
B := C;
_1:
W := B-A;
if (  not ( (W  = 0.e0) ) ) 
 then goto _2;
RINT := 0.e0;
E1 := 0.e0;
goto _39;
_2:
if ( BETA-ALFA ) < 0
 then goto _3
 else if ( BETA-ALFA ) > 0
       then goto _5
       else goto _4;
_3:
C := ALFA;
ALFA := BETA;
BETA := C;
goto _5;
_4:
ALFA := ALFA-HM;
BETA := BETA+HM;
_5:
ALFA := (ALFA-A)/W;
BETA := (BETA-A)/W;
TAU := (BETA-ALFA)/2.e0;
if ( TAU-HM ) < 0
 then goto _6
 else if ( TAU-HM ) > 0
       then goto _7
       else goto _6;
_6:
TAU := HM;
_7:
Z2 := E/W;
H := 1.e0;
N := 0;
_8:
P := 0.e0;
Z1 := EPS/W;
E1 := 0.e0;
RINT := 0.e0;
OM[0] := 0;
OM[1] := 0;
OM[2] := 0;
_9:
K := P+H;
if (  not ( (P  < BETA  ) and ( K  > ALFA  ) and ( H  > TAU) ) )
 then goto _10;
H := TAU;
if ( P  < ALFA ) 
 then H := ALFA-P;
if ( H  < TAU ) 
 then H := TAU;
_10:
K := P+H;
L := 0.e0;
M := 0.e0;
for O:=1 to 3 do
 begin
  if ( OM[O-1]  = 0 ) 
   then goto _11;
  I := D[O-1];
  goto _12;
_11:
  J := H*KSI[O-1]+P;
  D[O-1] := F(W*J+A);
  I := D[O-1];
  OM[O-1] := 1;
_12:
  L := L+AY[O-1]*I;
  M := M+BY[O-1]*I;
_13:
 end;
for O:=4 to 7 do
 begin
  J := H*KSI[O-1]+P;
  I := F(W*J+A);
  L := L+AY[O-1]*I;
  M := M+BY[O-1]*I;
_14:
 end;
L := H*L;
M := Abs(H*M);
if ( M-Z1 ) < 0
 then goto _15
 else if ( M-Z1 ) > 0
       then goto _25
       else goto _25;
_15:
P := K;
_16:
E1 := E1+M;
RINT := RINT+L;
I := 1.e0-P;
N := N+1;
if ( N-1 ) < 0
 then goto _18
 else if ( N-1 ) > 0
       then goto _18
       else goto _17;
_17:
H0 := H;
_18:
if ( 1.e0+I/64.e0-1.e0 ) < 0
 then goto _19
 else if ( 1.e0+I/64.e0-1.e0 ) > 0
       then goto _21
       else goto _19;
_19:
J := Abs(F(B))+Abs(D[2]);
J := J*I;
if ( J-Z2 ) < 0
 then goto _30
 else if ( J-Z2 ) > 0
       then goto _20
       else goto _30;
_20:
E1 := E1+J;
goto _30;
_21:
D[0] := D[2];
OM[1] := 0;
OM[2] := 0;
OM[0] := 1;
if ( M-Z1/IntPower(2.e0,7) ) < 0
 then goto _22
 else if ( M-Z1/IntPower(2.e0,7) ) > 0
       then goto _23
       else goto _23;
_22:
H := 2.e0*H;
_23:
if ( H-I ) < 0
 then goto _9
 else if ( H-I ) > 0
       then goto _24
       else goto _9;
_24:
H := I;
goto _9;
_25:
H := H/2.e0;
if ( 64.e0+H-64.e0 ) < 0
 then goto _26
 else if ( 64.e0+H-64.e0 ) > 0
       then goto _29
       else goto _26;
_26:
if ( P ) < 0
 then goto _27
 else if ( P ) > 0
       then goto _28
       else goto _27;
_27:
if ( H/4.e0 ) < 0
 then goto _28
 else if ( H/4.e0 ) > 0
       then goto _29
       else goto _28;
_28:
XA := (P+A)*W;
P := P+H*2.e0;
H := 2.e0*H;
goto _16;
_29:
D[2] := D[1];
OM[1] := 0;
goto _10;
_30:
Q := Z2*(1.e0+Abs(RINT));
if ( E1-Q ) < 0
 then goto _37
 else if ( E1-Q ) > 0
       then goto _31
       else goto _37;
_31:
if ( IL-1 ) < 0
 then goto _32
 else if ( IL-1 ) > 0
       then goto _32
       else goto _33;
_32:
R := Abs(RINT-RINT2);
if ( R-Q ) < 0
 then goto _36
 else if ( R-Q ) > 0
       then goto _33
       else goto _36;
_33:
RINT2 := RINT;
IL := 2;
EPS := EPS/IntPower(2.e0,7);
if ( XA+SYS059 ) < 0
 then goto _34
 else if ( XA+SYS059 ) > 0
       then goto _37
       else goto _34;
_34:
if ( EPS-SYS059 ) < 0
 then goto _36
 else if ( EPS-SYS059 ) > 0
       then goto _35
       else goto _36;
_35:
H := H0;
goto _8;
_36:
E1 := R;
_37:
RINT := RINT*W;
E1 := E1*W;
if (  not ( (NI) ) ) 
 then goto _38;
RINT := -RINT;
C := B;
B := A;
A := C;
_38:
ALFA := ALFA*W+A;
BETA := BETA*W+A;
_39:
end;

end.
